leetcode note--leetcode 167 Two Sum II - Input array is sorted

167. Two Sum II - Input array is sorted


Given an array of integers that is already sorted in ascending order, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

解法一:第一想法,效率比较低,用一个hashMap;map里存 key=(target-nums[i]) value=i 这样只要遇到正好的值,取出来就行了

public class Solution {
    public int[] twoSum(int[] numbers, int target) {
       int[] res = new int[2];
       Map<Integer,Integer> map = new HashMap<>();
       for(int i = 0;i < numbers.length;i++){
           if(map.containsKey(numbers[i])){
               res[0] = map.get(numbers[i])+1;
               res[1] = i+1;
               return res;
           }else{
               map.put(target-numbers[i],i);
           }
       }
       return res;
    }
}
time = 6ms;
方法二:充分利用排序好的特点,直接用两个指针,一前一后,和大于目标,后向前(和减小),和小于目标,前向后(和变大)

public class Solution {
    public int[] twoSum(int[] numbers, int target) {
        int[] res = new int[2];
        for(int i=0,j=numbers.length-1;i<j;){
            int	ni = numbers[i];
        	int nj = numbers[j];
        	if(ni+nj==target){
        		res[0] = i+1;
        		res[1] = j+1;
        	    return res;
        	}else if(ni+nj>target){
        		j--;
        	}else{
        		i++;
        	}
        }
        return res;
    }
}
time = 2ms;

方法三:方法二的改进版:剔除重复元素,也就是当前指针向后或后指针向前时,判断是不是重复元素,把重复元素跳过;

public class Solution {
    public int[] twoSum(int[] numbers, int target) {
        int[] res = new int[2];
        for(int i=0,j=numbers.length-1;i<j;){
            int	ni = numbers[i];
        	int nj = numbers[j];
        	if(ni+nj==target){
        		res[0] = i+1;
        		res[1] = j+1;
        	    return res;
        	}else if(ni+nj>target){
        		while(i<j && numbers[j]==numbers[j-1]) j--;
        		j--;
        	}else{
        		while(i<j && numbers[i]==numbers[i+1]) i++;//i已经在上边用过了,所以下边要再进行一次,到nums[i]不同的元素上去
        		i++;
        	}
        }
        return res;
    }
}
time=1ms;

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值